<?php
// +-----------------------------------------------------------------------+
// | PhpWebGallery - a PHP based picture gallery                           |
// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
// | Copyright (C) 2003-2005 PhpWebGallery Team - http://phpwebgallery.net |
// +-----------------------------------------------------------------------+
// | branch        : none
// | file          : $RCSfile: rvm.php,v $
// | last update   : $Date: 2006/04/19 22:33:05 $
// | last modifier : $Author: Eric $
// | revision      : $Revision: 1 $
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

// +-----------------------------------------------------------------------+
// |                             functions                                 |
// +-----------------------------------------------------------------------+
//language select creation
function rvm_language_select($available_lang,$default, $select_name = "language")
{
  $lang_select = '<select name="' . $select_name . '">';
  foreach ($available_lang as $code => $displayname)
  {
    $selected = ( strtolower($default) == strtolower($code) ) ? ' selected="selected"' : '';
    $lang_select .= '<option value="' . $code . '"' . $selected . '>' . ucwords($displayname) . '</option>';
  }
  
  $lang_select .= '</select>';

  return $lang_select;
}
// +-----------------------------------------------------------------------+
// |                           initialization                              |
// +-----------------------------------------------------------------------+
$categories = array();

$base_url = PHPWG_ROOT_PATH.'admin.php?page=';

if (!defined('IN_ADMIN'))
{
  define('PHPWG_ROOT_PATH','./');
  include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
}

// +-----------------------------------------------------------------------+
// |                           rvm management                             |
// +-----------------------------------------------------------------------+
if ($user['status'] == 'admin')
{
  //
  // GET
  //
  
  //delete a translation
  if (isset($_GET['action']) and $_GET['action']=='delt'
    and isset($_GET['idt'])  and is_numeric($_GET['idt'])
  )
  {
    //get rvm_id
    $query = '
    SELECT rvm_id
    FROM '.RVM_TRANSLATION_TABLE.'
     WHERE id = \''.$_GET['idt'].'\'
    ;';
    $result = pwg_query($query);
    $row = mysql_fetch_array($result);
    $rvm_id=$row['rvm_id'];
    
    
      //delete rvm_translation
  	$query = '
		DELETE FROM '.RVM_TRANSLATION_TABLE.'
		 WHERE id = \''.$_GET['idt'].'\'
		;';
		pwg_query($query);
		
		//get others translations of the rvm
		$query = '
		SELECT id
		 FROM '.RVM_TRANSLATION_TABLE.'
		 WHERE rvm_id = \''.$rvm_id.'\'
		;';
		$result = pwg_query($query);
		
		//if there is no others translations, delete the rvm
		if (mysql_num_rows ($result) <= 0)
		{
			$query = '
			DELETE FROM '.RVM_TABLE.'
			 WHERE id = \''.$rvm_id.'\'
			;';
			pwg_query($query);
			
			// information message
      $template->assign_block_vars('information',array('INFORMATION'=>$lang['rvm_deleted']));
		}
		else
		{
			// information message
      $template->assign_block_vars('information',array('INFORMATION'=>$lang['translation_deleted']));
		}
  }
  //delete a rvm
  else if (isset($_GET['action'])  and $_GET['action']=='deln'
    and isset($_GET['idn']) and is_numeric($_GET['idn'])
  )
  {
  	$query = '
		DELETE FROM '.RVM_TRANSLATION_TABLE.'
		 WHERE rvm_id = \''.$_GET['idn'].'\'
		;';
		pwg_query($query);
		
		$query = '
		DELETE FROM '.RVM_TABLE.'
		 WHERE id = \''.$_GET['idn'].'\'
		;';
		pwg_query($query);
		
		// information message
		$template->assign_block_vars('information',array('INFORMATION'=>$lang['rvm_deleted']));
  }
	
	//
	// POST
	//
	
	//add translation
	if (isset($_POST['addt'])
    and isset( $_POST['content'] ) and !empty($_POST['content'])
  )
	{	

		$message=$_POST['content'];
		
		$query = '
		INSERT INTO '.RVM_TRANSLATION_TABLE.'
		 (rvm_id, language, subject, content) VALUES (
		 '.$_POST['idn'].',
		 \''.$_POST['language'].'\',
		 \''.$_POST['subject'].'\',
		 \''.$message.'\'
		);';
		
		pwg_query( $query );
		// information message
		$template->assign_block_vars('information',array('INFORMATION'=>$lang['translation_added']));
	}
	//mod translation
	else if (isset($_POST['modt'])
    and isset( $_POST['content'] ) and !empty($_POST['content'])
  )
	{

	$message=$_POST['content'];
		
		$query = '
		 UPDATE '.RVM_TRANSLATION_TABLE.'
		 SET language=\''.$_POST['language'].'\',
		 subject=\''.$_POST['subject'].'\',
		 content=\''.$message.'\'
     WHERE id=\''.$_POST['idt'].'\'
		;';
		
		pwg_query( $query );
		// information message
		$template->assign_block_vars('information',array('INFORMATION'=>$lang['translation_altered']));		
	}
	//add rvm
	else if (isset($_POST['addn'])
    and isset( $_POST['content'] ) and !empty($_POST['content'])
  )
	{

	$message=$_POST['content'];
		
		$query = '
		INSERT INTO '.RVM_TABLE.'
		(date) VALUES (
		NOW()
		);';
	
		pwg_query( $query );

		$query = '
		INSERT INTO '.RVM_TRANSLATION_TABLE.'
		 (rvm_id, language, subject, content) VALUES (
		 LAST_INSERT_ID(),
		 \''.$_POST['language'].'\',
		 \''.$_POST['subject'].'\',
		 \''.$message.'\'		 
		);';

		pwg_query( $query );
		
		// information message
		$template->assign_block_vars('information',array('INFORMATION'=>$lang['rvm_added']));
		
		$page['start']=0;
	}
}
else

// +-----------------------------------------------------------------------+
// |                       page header and options                         |
// +-----------------------------------------------------------------------+

$page['args']=2;

if (defined('IN_ADMIN'))
{
  $page['args'].= '&amp;page=rvm';
} 


if (!defined('IN_ADMIN'))
{
  $title= $lang['title_rvm'];
  include(PHPWG_ROOT_PATH.'include/page_header.php');
}

$template->set_filenames(array('rvm'=>'rvm.tpl'));

$template->assign_vars(
  array(
    'L_RVM_TITLE' => $title,
    'L_RVM_PER_PAGE'=>$lang['rvm_per_page'],
    'L_RETURN_HINT' => $lang['home_hint'],
    'L_MODIFY' =>$lang['modify'],
    'L_MODIFY_TRANSLATION_HINT' => $lang['modify_translation'],
    'L_EDIT_TRANSLATION_HINT' => $lang['edit category informations'],
    'L_DELETE' =>$lang['delete'],
    'L_DELETE_TRANSLATION_HINT' => $lang['delete_translation'],
    'L_NO_RVM_TRANSLATION'=>$lang['no_rvm_translation'],
    'L_TRANSLATE'=>$lang['translate'],
    'L_TRANSLATE_RVM_HINT' => $lang['post_translation'],
    'L_DELETE_RVM_HINT' => $lang['delete_rvm_hint'],
    'L_SUBMIT' =>$lang['submit'],
    'L_BACK' => $lang['back'],
    'L_BACK_HINT' => $lang['back_rvm_hint'],
	'L_YES'=>$lang['yes'],
	'L_NO'=>$lang['no'],
    'F_ACTION'=>add_session_id($form_action),
    'U_HOME' => add_session_id(PHPWG_ROOT_PATH.'category.php'),
    'U_POST_RVM'=> add_session_id($_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=addn'),
    'U_RVM'=>add_session_id( $_SERVER['PHP_SELF'].'?'.$page['args']),
    )
  );
// +-----------------------------------------------------------------------+
// |                        DISPLAY FORMS                                  |
// +-----------------------------------------------------------------------+

//
//display form to add rvm
//
if ($user['status'] == 'admin'
  and isset($_GET['action']) and $_GET['action']=='addn'
)
{
   //display add a RVM in h2 tags
  
$template->assign_block_vars(
  'new_rvm',
  array(
        )
    );
  //get every languages
  $available_lang=get_languages();
  
	$lang_select=rvm_language_select($available_lang,$user['language']);
	
	$template->assign_block_vars(
    'form',
    array(
      'MESSAGE'=>$lang['post_rvm'],
      'LANG_SELECT'=>$lang_select,
      'SUBMIT_NAME' =>'addn'
      )
  );	
}
//
//display form to add a translation
//
else if ($user['status'] == 'admin'
  and isset($_GET['action']) and $_GET['action']=='addt'
  and isset($_GET['idn']) and is_numeric($_GET['idn'])
)
{
     //display add a translation title in h2 tags
  
$template->assign_block_vars(
  'rvm_translation',
  array(
        )
    );
    
  //get every languages
  $available_lang=get_languages();
  $not_translated_languages=$available_lang;

  
  //display date
  $query = '
  SELECT DISTINCT(id) AS rvm_id, date
   FROM '.RVM_TABLE.'
   WHERE id=\''.$_GET['idn'].'\'
  ;';
  
  $result = pwg_query($query);
  $row = mysql_fetch_array($result);
  
  $template->assign_block_vars(
    'rvm',
    array(
      'RVM_DATE'=>format_date($row['date'],'mysql_datetime',true),
  ));
      
  //display the rvm translations
  $query = '
  SELECT id AS rvm_translation_id,language,subject,content
   FROM '.RVM_TRANSLATION_TABLE.'
   WHERE rvm_id = \''.$_GET['idn'].'\'
  ;';

  $subresult = pwg_query($query);
  
  while ($subrow = mysql_fetch_array($subresult))
  {
    $message=preg_replace('/\:[0-9a-z\:]+\]/si', ']', $subrow['content']);
    $message = str_replace("\n", "\n<br />\n", $message);
    
    $template->assign_block_vars('rvm.rvm_translation',
     array(
     'SUBJECT'=>$subrow['subject'],
     'CONTENT'=>$message
    ));	
    
    $template->assign_block_vars(
      'rvm.rvm_translation.admin',
      array(	
        'LANG_TITLE' => ucwords($available_lang[$subrow['language']]),
    ));    
    
    //delete language from not translated languages table
    $keys_indexes=array_flip(array_keys($not_translated_languages));
    array_splice ($not_translated_languages, $keys_indexes[$subrow['language']],1);
  }
      
	$lang_select=rvm_language_select($not_translated_languages,$user['language']);

  $template->assign_block_vars(
    'form',
    array(
      'MESSAGE'=>$lang['post_translation'],
      'RVM_ID'=>$_GET['idn'],
      'LANG_SELECT'=>$lang_select,
      'SUBMIT_NAME' =>'addt'
      )
  ); 
}
//
//display form to alter a translation
//
else if ($user['status'] == 'admin'
  and isset($_GET['action']) and $_GET['action']=='modt' 
  and isset($_GET['idt']) and is_numeric($_GET['idt'])
)
{
  //display edit rvm title in h2 tags
  
$template->assign_block_vars(
  'title_edit_rvm',
  array(
        )
    );
   //get every languages
  $available_lang=get_languages();
  $not_translated_languages=$available_lang;
     
  //get the rvm translation
  $query = '
  SELECT id AS rvm_translation_id,language,subject,content,rvm_id
   FROM '.RVM_TRANSLATION_TABLE.'
   WHERE id = \''.$_GET['idt'].'\'
  ;';

  $result = pwg_query($query);
  $row = mysql_fetch_array($result);

  //
  //display date
  //
  $query = '
  SELECT DISTINCT(id) AS rvm_id, date
   FROM '.RVM_TABLE.'
   WHERE id=\''.$row['rvm_id'].'\'
  ;';
  
  $subresult = pwg_query($query);
  $subrow = mysql_fetch_array($subresult);
 
  //
 //display the rvm translations
 //
  $query = '
  SELECT id AS rvm_translation_id,language,subject,content
   FROM '.RVM_TRANSLATION_TABLE.'
   WHERE rvm_id = \''.$row['rvm_id'].'\'
   AND id!=\''.$_GET['idt'].'\'
  ;';

  while ($subrow = mysql_fetch_array($subresult))
  {
      $message=preg_replace('/\:[0-9a-z\:]+\]/si', ']', $subrow['content']);
      $message = str_replace("\n", "\n<br />\n", $message);
        
      $template->assign_block_vars(
        'rvm.rvm_translation',
        array(
        'SUBJECT'=>$subrow['subject'],
        'CONTENT'=>$message
      ));	
      
      $template->assign_block_vars(
        'rvm.rvm_translation.admin',
        array(	
          'LANG_TITLE' => ucwords($available_lang[$subrow['language']]),
      ));    
    

      //delete language from not translated languages table
      $keys_indexes=array_flip(array_keys($not_translated_languages));
      array_splice ($not_translated_languages, $keys_indexes[$subrow['language']],1);
  }

$query = '
SELECT *
  FROM '.RVM_TRANSLATION_TABLE.'
  WHERE id = \''.$_GET['idt'].'\'
;';
  
//get every languages
  $lang_select=rvm_language_select($not_translated_languages,$row['language']);
  
  $message=preg_replace('/\:[0-9a-z\:]+\]/si', ']', $row['content']);
  
  $template->assign_block_vars(
    'form',
    array(
      'MESSAGE'=>$lang['post_translation'],
      'RVM_TRANSLATION_ID'=>$_GET['idt'],
      'LANG_SELECT'=>$lang_select,
      'SUBJECT'=> $row['subject'],
      'RVM_DATE'=>format_date($subrow['date'],'mysql_datetime',true),
      'CONTENT'=> $message,
      'SUBMIT_NAME' =>'modt',
      'L_RVM_TITLE' => $title
      )
    );
   
  }
  
//
// display rvm
//
else
{
  $url = $_SERVER['PHP_SELF'];
  if (defined('IN_ADMIN'))
  {
  $url.= '&amp;page=rvm';
  }
  
  // +-----------------------------------------------------------------------+
  // |                          last rvm display                            |
  // +-----------------------------------------------------------------------+
  
  if ($user['status'] == 'admin')
  {
    $template->assign_block_vars('admin',array());
  }
  
  //get every languages
  $available_lang=get_languages();
  
  
  if ($user['status'] == 'admin')
{
// display all RVM text
$query = '
		SELECT DISTINCT(n.id) AS rvm_id
		, n.date
		FROM '.RVM_TABLE.' as n
		ORDER BY date DESC
	;';
$result = pwg_query($query);
}
  while ($row = mysql_fetch_array($result))
  {
    $rvm_id = $row['rvm_id'];
  
    $template->assign_block_vars(
    'rvm',
    array(
      'RVM_DATE'=>format_date($row['date'],'mysql_datetime',true),
      ));
  
    //get the rvm translation
    $query = '
    SELECT id AS rvm_translation_id,language,subject,content
     FROM '.RVM_TRANSLATION_TABLE.'
     WHERE rvm_id = \''.$rvm_id.'\'
    ';
    
    $no_rvm_translation=false;
    
    if ($user['status'] != 'admin')
    {
      $subresult = pwg_query($query.'AND language = \''.$user['language'].'\';');
      $subrow = mysql_fetch_array($subresult);
        
      //there is a no translation for the user language
      if (empty($subrow))
      {
        $no_rvm_translation=true;
      
        //get the default translation	
        $subresult = pwg_query($query.'AND language = \''.$conf['language'].'\';');
        $subrow = mysql_fetch_array($subresult);
          
        //there is no translation for the default language
        if (empty($subrow))
        {
          //get the first translation			
          $subresult = pwg_query($query.'LIMIT 1;');
          $subrow = mysql_fetch_array($subresult);
        }		
      }
      
	  $message=$subrow['content'];
      
      $template->assign_block_vars(
        'rvm.rvm_translation',
        array(
          'SUBJECT'=>$subrow['subject'],
          'CONTENT'=>$message,
      ));	
         
      //there is no translation for this rvm
      if ($no_rvm_translation)
      {
        $template->assign_block_vars('rvm.rvm_translation.no_rvm_translation', array());
      }
    }
    else //this is an admin
    {
	 
	 //get every translations				
      $subresult = pwg_query($query);

      $not_translated_languages=$available_lang;
  
      //show every translation
      while ($subrow = mysql_fetch_array($subresult))
      {

	$message=$subrow['content'];
        
        $template->assign_block_vars(
          'rvm.rvm_translation',
          array(
          'SUBJECT'=>$subrow['subject'],
          'CONTENT'=>$message
        ));	
        
        $template->assign_block_vars(
          'rvm.rvm_translation.admin',
          array(	
            'LANG_TITLE' => ucwords($available_lang[$subrow['language']]),
        ));
        
	
	if (($user['status'] == 'admin') and ($_GET['page']=='rvm'))
	{
	
        $template->assign_block_vars(
          'rvm.rvm_translation.admin_link',
          array(
	    'U_TRANSLATE' => add_session_id( $_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=addt&amp;idn='.$rvm_id),
	    'U_MODIFY'=> add_session_id( $_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=modt&amp;idt='.$subrow['rvm_translation_id']),
        'U_DELETE'=> add_session_id( $_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=delt&amp;idt='.$subrow['rvm_translation_id'])
        ));

        //delete language from not translated languages table
        $keys_indexes=array_flip(array_keys($not_translated_languages));
        array_splice ($not_translated_languages, $keys_indexes[$subrow['language']],1);
      	}
      }
      if (($user['status'] == 'admin') and ($_GET['page']=='rvm'))
      {
      $template->assign_block_vars(
        'rvm.rvm_translation.admin_link.translate_hlink',
        array(
          'U_DELETE' => add_session_id($_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=deln&amp;idn='.$rvm_id)
      ));
      
      //rvm not translated in every languages
      if (count($not_translated_languages)>0)
      {
        $template->assign_block_vars(
          'rvm.rvm_translation.admin_link.translate_hlink',
          array(
            'U_TRANSLATE' => add_session_id( $_SERVER['PHP_SELF'].'?'.$page['args'].'&amp;action=modt&amp;idt='.$rvm_id), 
        ));
      }
      }
    }
  }
}

// +-----------------------------------------------------------------------+
// |                           html code display                           |
// +-----------------------------------------------------------------------+
if (defined('IN_ADMIN'))
{
  $template->assign_var_from_handle('ADMIN_CONTENT', 'rvm');
}
else
{
  $template->assign_block_vars('title',array());
  $template->parse('rvm');
  include(PHPWG_ROOT_PATH.'include/page_tail.php');
}
?>